Page MenuHomeFreeBSD

kboot: Improve amd64 booting
ClosedPublic

Authored by imp on Jan 29 2023, 3:16 PM.
Tags
None
Referenced Files
F81975360: D38259.diff
Wed, Apr 24, 12:03 AM
F81969606: D38259.id116260.diff
Tue, Apr 23, 9:55 PM
Unknown Object (File)
Sat, Apr 6, 11:05 PM
Unknown Object (File)
Sat, Apr 6, 2:43 PM
Unknown Object (File)
Mar 22 2024, 9:57 PM
Unknown Object (File)
Mar 22 2024, 9:57 PM
Unknown Object (File)
Mar 22 2024, 9:54 PM
Unknown Object (File)
Mar 22 2024, 9:54 PM
Subscribers

Details

Summary

Copy more of the necessary state for FreeBSD to boot:
o Copy EFI memory tables
o Create custom page tables needed for the kernel to find itself
o Simplify the passing of args to the trampoline by putting them

on the stack rather than in dedicated memory.

This is only partially successful... we get only part way through the
amd64 startup code before dying. However, it's much further than before
the changes.

Sponsored by: Netflix

Diff Detail

Repository
rG FreeBSD src repository
Lint
Lint Skipped
Unit
Tests Skipped
Build Status
Buildable 49454
Build 46344: arc lint + arc unit

Event Timeline

imp requested review of this revision.Jan 29 2023, 3:16 PM

rebase / refactor / redo

kevans added inline comments.
stand/kboot/arch/amd64/amd64_tramp.S
31
This revision is now accepted and ready to land.Feb 2 2023, 3:46 AM
This revision now requires review to proceed.Feb 2 2023, 4:06 AM
This revision is now accepted and ready to land.Feb 2 2023, 10:49 PM
This revision was automatically updated to reflect the committed changes.